<!DOCTYPE html>
<html>
   <head>
      <title>2-3 Tree</title>
      <style>
         .exp {
             display: none;
         }
         table {
             font-family: arial, sans-serif;
             border-collapse: collapse;
             width: 100%;
             text-align: center;
         }
         th {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         #headings {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         td {
             border: 1px solid #dddddd;
             padding: 8px;
             text-align: center;
             height:20px;
         }
         tr:hover {
             background-color: #ddd;
         }
        </style>
      <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
      <meta charset="utf-8" />
        <!-- Google Tag Manager -->
        <script class="gtm">
          window.dataLayer = window.dataLayer || [];
          
          window.dataLayer.push ({
          'labName': 'Data Structures – 2',
          'discipline': 'Computer Science and Engineering',
          'college': 'IIITH',
          'phase': '3',
          'expName': '2-3 Trees',
          'expShortName': '2-3-tree'
          });




          (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
          new Date().getTime(),event:'gtm.js'});var
          f=d.getElementsByTagName(s)[0],
          j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
          'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
          })(window,document,'script','dataLayer','GTM-W59SWTR');
        </script>
         <!-- End Google Tag Manager -->
   </head>
   <body>
        <!-- Google Tag Manager (noscript) -->
        <noscript class="gtm">
          <iframe height="0" width="0"
            src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
            style="display:none;visibility:hidden">
          </iframe>
        </noscript>

        <!-- End Google Tag Manager (noscript) -->
      <div class="exp" title="2-3 Tree">
         <div class="longt">
            <h1 class="hlongt">Introduction to 2-3 Tree</h1>
         </div>
         <div class="preamble">
            <div class="art txt" title="Estimation">
               <div class="longt">
                  <h2 class="hlongt">Estimated Time</h2>
               </div>
               <div class="art-body">
                  <p>1 hour</p>
               </div>
            </div>
            <div class="art txt" title="Prerequisites">
               <div class="longt">
                  <h2 class="hlongt">Prerequisites of the Experiment</h2>
               </div>
               <div class="art-body">
                  <ul>
                     <li>
                        Basic knowledge of
                        <ul>
                           <li>
                              <a href="https://www.geeksforgeeks.org/binary-tree-data-structure/">Binary Tree</a>
                           </li>
                           <li>
                              <a href="https://www.geeksforgeeks.org/binary-search-tree-data-structure/">Binary Search Tree</a>
                           </li>
                        </ul>
                     </li>
                     <li>And above all, a curiosity to learn and explore!</li>
                  </ul>
               </div>
            </div>
            <div class="art txt" title="Overview">
               <div class="longt">
                  <h2 class="hlongt">Overview of the Experiment</h2>
               </div>
               <div class="art-body">
                  <p>The experiment features a series of
                     modules with video lectures, hands-on
                     practice exercises and quizzes for self
                     analysis.
                  </p>
               </div>
            </div>
            <div class="art txt" title="Learning Objectives">
               <div class="longt">
                  <h2 class="hlongt">Learning Objectives of the Experiment</h2>
               </div>
               <div class="art-body">
                  <p>In this experiment, we will learn the following:<br>
                  <ul>
                     <li>
                        Structure, representation and implementation of 2-3 Tree data structure.
                     </li>
                     <li>
                        Insertion in a 2-3 tree.
                     </li>
                     <li>
                        Deletion from a 2-3 tree.
                     </li>
                     <li>
                        Find/Search in a 2-3 tree.
                     </li>
                  </ul>
                  </p>
               </div>
            </div>
            <div class="art txt" title="Modules and Weightage">
              <div class="longt">
                  <h2 class="hlongt">Experiment Modules & their Weightage</h2>
              </div>
              <div class="art-body">
                  <table>
                      <thead>
                          <tr>
                              <th style="text-align:center">Module</th>
                              <th style="text-align:center">Weightage</th>
                              <th style="text-align:center">Expectation</th>
                          </tr>
                      </thead>
                      <tbody>
                          <tr>
                              <td>Pre-test</td>
                              <td>15%</td>
                              <td>Solve All Questions</td>
                          </tr>
                          <tr>
                              <td>2-3 Basics</td>
                              <td>25%</td>
                              <td>Understand the 2-3 Tree basics</td>
                          </tr>
                          <tr>
                              <td>Operations</td>
                              <td>35%</td>
                              <td>Understand the 2-3 Tree Algorithm</td>
                          </tr>
                          <tr>
                              <td>Post-test</td>
                              <td>25%</td>
                              <td>Solve all Questions</td>
                          </tr>
                      </tbody>
                  </table>
              </div>
            </div>
         </div>
         <div class="lu" title="Pre-Test">
            <div class="longt">
               <h1 class="hlongt">Pre-test of the Experiment</h1>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>10 minutes</p>
                  </div>
               </div>
               <div class="art txt" title="Instructions">
                  <div class="longt">
                     <h2 class="hlongt">Instructions for Pre-test</h2>
                  </div>
                  <div class="art-body">
                     <p>Pretest includes questions on
                     <ul>
                        <li>Binary Trees</li>
                        <li>Binary Search Trees</li>
                     </ul>
                     Read the questions below and select
                     the correct options from the ones given.
                     Some questions may have multiple correct
                     answers.
                     </p>
                  </div>
               </div>
            </div>
      <div class="quiz" title="Pre-Test Quiz">
              <div class="longt">
                  <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
              </div>
              
              <div class="mcq">  
                  <div class="preamble">
                      <div class="art txt" title="question1">
                          <div class="art-body">
                              <p>Q1. Which of the following statements are correct about a binary tree? </p>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q1-c1">
                              <div class="art-body">
                                  <p>(A) A node in a binary tree can have exactly two children</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="true">
                      <div class="preamble">
                          <div class="art txt" title="q1-c2">
                              <div class="art-body">
                                  <p>(B) A node in a binary tree can have atmost two children</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q1-c3">
                              <div class="art-body">
                                  <p>(C) A node in a binary tree can have two or more children</p> 
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q1-c4">
                              <div class="art-body">
                                  <p>(D) A node in a binary tree can have two or more children</p> 
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="explanation">
                      <div class="art txt" title="Explanation">
                          <div class="art-body">
                              <p>A node in a binary tree, by definition, can have atmost two children.
                              </p>
                          </div>
                      </div>
                  </div>
              </div>

              <div class="mcq">  
                  <div class="preamble">
                      <div class="art txt" title="question2">
                          <div class="art-body">
                              <p>Q2. Node values in a binary tree always appear in a sorted order from root to leaf, going left to right at each level. </p>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q2-c1">
                              <div class="art-body">
                                  <p>(A) True</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="true">
                      <div class="preamble">
                          <div class="art txt" title="q2-c2">
                              <div class="art-body">
                                  <p>(B) False</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="explanation">
                      <div class="art txt" title="Explanation">
                          <div class="art-body">
                              <p>There is no specific order in which keys are stored in a binary tree.
                              </p>
                          </div>
                      </div>
                  </div>
              </div>
              <div class="mcq">  
                  <div class="preamble">
                      <div class="art txt" title="question3">
                          <div class="art-body">
                              <p>Q3. Which of the following is TRUE about the leaf nodes of a binary tree? 
                              </p>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="true">
                      <div class="preamble">
                          <div class="art txt" title="q1-c1">
                              <div class="art-body">
                                  <p>(A) Leaf nodes in a binary tree have no children</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q1-c2">
                              <div class="art-body">
                                  <p>(B) Atleast one leaf node in a binary tree has two chidren</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q1-c3">
                              <div class="art-body">
                                  <p>(C) Leaf nodes in a binary tree are allowed to have more than two children</p> 
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q1-c4">
                              <div class="art-body">
                                  <p>(D) Leaf nodes in a binary tree may or may not have child nodes
</p> 
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="explanation">
                      <div class="art txt" title="Explanation">
                          <div class="art-body">
                              <p>Leaf nodes in a binary tree have no children, and this is the reason why they are called "leaf". Leaf nodes appear at the last level of the tree.
                              </p>
                          </div>
                      </div>
                  </div>
              </div>

              <div class="mcq">  
                  <div class="preamble">
                      <div class="art txt" title="question4">
                          <div class="art-body">
                              <p>
                                 Q4. In a binary search tree all nodes in the left subtree are __________. 
                              </p>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="true">
                      <div class="preamble">
                          <div class="art txt" title="q2-c1">
                              <div class="art-body">
                                  <p>(A) SMALLER than the root</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q2-c2">
                              <div class="art-body">
                                  <p>(B) GREATER than the root</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q2-c3">
                              <div class="art-body">
                                  <p>(C) EQUAL to the root</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="explanation">
                      <div class="art txt" title="Explanation">
                          <div class="art-body">
                              <p>All nodes in the left subtree of the root in a binary search tree are smaller than the root.
                              </p>
                          </div>
                      </div>
                  </div>
              </div>

              <div class="mcq">  
                  <div class="preamble">
                      <div class="art txt" title="question4">
                          <div class="art-body">
                              <p>
                                 Q5. What is the worst case height possible in a binary search tree? Let N be the number of nodes in the tree. 
                              </p>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q2-c1">
                              <div class="art-body">
                                  <p>(A) O(log N)</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="true">
                      <div class="preamble">
                          <div class="art txt" title="q2-c2">
                              <div class="art-body">
                                  <p>(B) O(N)</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q2-c3">
                              <div class="art-body">
                                  <p>(C) O(1)</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="choice" data-correct="false">
                      <div class="preamble">
                          <div class="art txt" title="q2-c3">
                              <div class="art-body">
                                  <p>(D) None of the above</p>
                              </div>
                          </div>
                      </div>
                  </div>
                  <div class="explanation">
                      <div class="art txt" title="Explanation">
                          <div class="art-body">
                              <p>A BST need not be balanced and therefore, the worst case height possible is O(N), where N is the number of nodes in the tree. 
                              </p>
                          </div>
                      </div>
                  </div>
              </div>
            </div>
         </div>
         <div class="lu" title="2-3 Tree Basics">
            <div class="longt">
               <h2 class="hlongt">Basics of 2-3 Tree</h2>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>15 minutes</p>
                  </div>
               </div>
               <div class="art txt" title="Introduction">
                  <div class="longt">
                     <h2 class="hlongt">Introduction to 2-3 Tree</h2>
                  </div>
                  <div class="art-body">
                     <p>Welcome to this module on tree 2-3 trees!
                        Take a look at what you will go
                        through in the module.
                     <ul>
                        <li>What is a 2-3 tree?</li>
                        <li>Different types of nodes in a 2-3 tree.</li>
                        <li>Various operations.</li>
                        <li>A quiz to check your
                           understanding of
                           concepts of 2-3 tree
                        </li>
                     </ul>
                     </p>
                  </div>
               </div>
            </div>
            <div class="task" title="Basics of 2-3 Tree">
               <div class="longt">
                  <h2 class="hlongt">Basics of 2-3 Tree</h2>
               </div>
               <div class="art req" title="2-3 Video Introduction">
                  <div class="longt">
                     <h2 class="hlongt">Welcome to 2-3 tree Experiment!</h2>
                  </div>
                  <div class="description">
                     <p>Video introduction to 2-3 tree experiment
                        should be displayed here!
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Definition">
                  <div class="longt">
                     <h2 class="hlongt">Definition</h2>
                  </div>
                  <div class="art-body">
                     <p>
                        2–3 tree is a perfectly balanced binary search tree. <i>It is called a 2-3 tree because each internal node has either 2 or 3 children.</i> In 2-3 tree, every path from root to leaf has the same length and the data structure guarantees worst case O(log n) time complexity for search and insert operations.
                     </p>
                  </div>
               </div>
               <div class="art txt" title="2-3 Nodes">
                  <div class="longt">
                     <h2 class="hlongt">2-3 Nodes</h2>
                  </div>
                  <div class="art-body">
                     <p>
                        There are three types of nodes in a 2-3 tree<br>
                     <ul>
                        <li><b>2 Node:</b> An internal node is a 2-node if it has one data element and two children.<br></li>
                        <li><b>3 Node:</b> An internal node is a 3-node if it has two data elements and three children.<br></li>
                        <li><b>Leaf Node:</b> A leaf node contains only data elements and has no children.</li>
                     </ul>
                     </p>
                  </div>
               </div>
               <div class="art req" title="2-3 Nodes Representation">
                  <div class="longt">
                     <h2 class="hlongt">Pictorial Representation of 2-3 tree nodes </h2>
                  </div>
                  <div class="description">
                     Pictorial Representation of 2-3 tree
                  </div>
               </div>
               <div class="art txt" title="Properties">
                  <div class="longt">
                     <h2 class="hlongt">Properties of 2-3 tree</h2>
                  </div>
                  <div class="art-body">
                     <p>
                        2-3 tree has the following properties:<br>
                     <ul>
                        <li>Every internal node is a 2-node or a 3-node.</li>
                        <li>All leaves are at the same level.</li>
                        <li>
                           All data is kept in <b>sorted order</b>. This means that:
                           <ul>
                              <li>In case of a <b>2 Node,</b> data items in left subtree are smaller than root and data items in right subtree are greater than root.</li>
                              <li>In case of a <b>3 Node,</b> data items in left subtree are smaller than root, data items in middle subtree are greater than root and data items in the right subtree are greater than the root and middle subtree.</li>
                           </ul>
                        </li>
                     </ul>
                     </p>
                  </div>
               </div>
               <div class="art txt" title="2-3 Tree vs BST">
                  <div class="longt">
                     <h2 class="hlongt">2-3 Tree vs BST</h2>
                  </div>
                  <div class="art-body">
                     <p>
                     <ul>
                        <li>The main advantage with 2-3 trees is that it is balanced in nature as opposed to a binary search tree whose height in the worst case can be O(N). </li>
                        <li>Due to this, the worst case time-complexity of operations such as search, insertion and deletion is O(Log(N)) as the height of a 2-3 tree is O(Log(N)).</li>
                     </ul>
                     </p>
                  </div>
               </div>
            </div>
            <div class="quiz" title="2-3 Tree Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>
                    
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Which of the following is true?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Data in a 2-3 tree is stored in unsorted manner</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Data in a 2-3 tree is stored in a sorted manner</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) There is no ordering among data items in a 2-3 tree</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Only leaf nodes have sorted data items</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Data items in a 2-3 tree are stored in a sorted manner. The left subtree has data items smaller than the root, the middle subtree has data item greater than root and smaller than right subtree and the right subtree has data items greater than left and middle subtree.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. Which of the following is true?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) Leaf nodes in a 2-3 tree can be at any level</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) Leaf nodes in a 2-3 tree can be only at odd levels</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) All leaf nodes in a 2-3 have the same level</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) None of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>An important property of 2-3 is that all leaf nodes have the same level.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. Which of the following best describes a 2-node? 
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) A 2-node has one data item and two children</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) A 2-node has two data items and two children</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) A 2-node has one data item and one child</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) None of the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>By definition, a 2-node has one data item and two children.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>
                                       Q4. Which of the following best describes a 3-node? 
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) A 3-node has one data item and two children</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) A 3-node has two data items and three children</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) A 3-node has one data item and one child</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) None of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>
                                       By definition, A 3-node has two data items and three children. 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
         </div>
         <div class="lu" title="Operations">
            <div class="longt">
               <h1 class="hlongt">Operations</h1>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>30 minutes</p>
                  </div>
               </div>
               <div class="art txt" title="Operations on 2-3 trees">
                  <div class="longt">
                     <h2 class="hlongt">Operations on 2-3 trees</h2>
                  </div>
                  <div class="art-body">
                     <p>Welcome to this module on operations on 2-3 tree! Take a look at what you
                        will go through in this module.
                     <ul>
                        <li>Insertion in a 2-3 tree</li>
                        <li>Search in a 2-3 tree</li>
                        <li>Deletion in a 2-3 tree</li>
                        <li>A quiz to check your
                           understanding of
                           2-3 tree.
                        </li>
                     </ul>
                     </p>
                  </div>
               </div>
            </div>
            <div class="task" title="Search">
               <div class="longt">
                  <h2 class="hlongt">Search</h2>
               </div>
               <div class="art req" title="2-3 Search Video">
                  <div class="longt">
                     <h2 class="hlongt">2-3 Search Video</h2>
                  </div>
                  <div class="description">
                     <p>2-3 Search Video
                        should be displayed here!
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Intuition">
                  <div class="longt">
                     <h2 class="hlongt">Intuition</h2>
                  </div>
                  <div class="art-body">
                     <p>
                        Searching for an item in a 2–3 tree is similar to searching for an item in a binary search tree. Since the data elements in each node are ordered, a search function will be directed to the correct subtree and eventually to the correct node which contains the item.
                     </p>
                  </div>
               </div>
               <div class="art req" title="Search: 2-Node">
                  <div class="longt">
                     <h2 class="hlongt">Search in a 2-Node</h2>
                  </div>
                  <div class="description">
                     Search in a 2-Node
                  </div>
               </div>
               <div class="art req" title="Search: 3-Node">
                  <div class="longt">
                     <h2 class="hlongt">Search in a 3-Node</h2>
                  </div>
                  <div class="description">
                     Search in a 3-Node
                  </div>
               </div>
               <div class="art txt" title="Algorithm">
                  <div class="longt">
                     <h2 class="hlongt">Algorithm</h2>
                  </div>
                  <div class="art-body">
                     <ul>
                        <li>1. Let <b>T</b> be a 2–3 tree and <b>d</b> be the data element we want to find. If <b>T</b> is <b>empty,</b> then d is not in T and we're <b>done.</b></li>
                        <li>2. Let <b>r</b> be the root of T.</li>
                        <li>
                           3. Suppose <b>r is a leaf</b>. <br>
                           <ul>
                              <li><b>If d is not in r</b>, then d is not in T and we're <b>done.</b></li>
                              <li><b>Otherwise, d is in T.</b> In particular, d can be found at a leaf node. We need no further steps and we're done.</li>
                           </ul>
                        </li>
                        <li>
                           4. Suppose <b>r is a 2-node</b> with left child L and right child R. Let e be the data element in r. There are three cases:<br>
                           <ul>
                              <li>If <b>d = e</b>, then we've found d in T and we're <b>done.</b></li>
                              <li>If <b>d &lt e,</b> then set T to L, which by definition is a 2–3 tree, and <b>go back to step 2.</b></li>
                              <li>If <b>d > e,</b> then set T to R and <b>go back to step 2.</b></li>
                           </ul>
                        </li>
                        <li>
                           5. Suppose <b>r is a 3-node</b> with left child L, middle child M, and right child R. Let a and b be the two data elements of r, where a &lt b. There are four cases:<br>
                           <ul>
                              <li>If <b>d is equal to a or b</b>, then d is in T and we're done.</li>
                              <li>If <b>d &lt a,</b> then set T to L and <b>go back to step 2.</b></li>
                              <li>If <b>a &lt d &lt b,</b> then set T to M and <b>go back to step 2.</b></li>
                              <li>If <b>d > b,</b> then set T to R and <b>go back to step 2.</b></li>
                           </ul>
                        </li>
                     </ul>
                  </div>
               </div>
            </div>
            <div class="task" title="Insertion">
               <div class="longt">
                  <h2 class="hlongt">Insertion</h2>
               </div>
               <div class="art req" title="2-3 Insertion Video">
                  <div class="longt">
                     <h2 class="hlongt">2-3 Insertion Video</h2>
                  </div>
                  <div class="description">
                     <p>2-3 Insertion Video
                        should be displayed here!
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Intuition">
                  <div class="longt">
                     <h2 class="hlongt">Intuition</h2>
                  </div>
                  <div class="art-body">
                     <p>
                        Insertion in a 2-3 tree is very different from a Binary Search Tree as in a 2-3 tree, a node can have one data item (2-Node) or two data items (3-Node). At first, we search for the correct position of the new data element to be inserted into the tree. Once, we have found the postion of the new data element, one of the two conditions arise:<br>
                     <ul>
                        <li>The data element is to be inserted as a new node. In this case, we simply create a new node and insert the data element.</li>
                        <li>In another case, the new data element is to be inserted in an already full node. Here, full node means a node which cannot accomodate any new element. This results in <b>splitting</b> of the node</li>
                     </ul>
                     </p>
                  </div>
               </div>
               <div class="art req" title="Insert Example 1">
                  <div class="longt">
                     <h2 class="hlongt">Insert in a node with only one data element</h2>
                  </div>
                  <div class="description">
                     Insert in a node with only one data element
                  </div>
               </div>
               <div class="art req" title="Insert Example 2">
                  <div class="longt">
                     <h2 class="hlongt">Insert in a node with two data elements whose parent contains only one data element.</h2>
                  </div>
                  <div class="description">
                     Insert in a node with two data elements whose parent contains only one data element.
                  </div>
               </div>
               <div class="art req" title="Insert Example 3">
                  <div class="longt">
                     <h2 class="hlongt">Insert in a node with two data elements whose parent also contains two data elements.</h2>
                  </div>
                  <div class="description">
                     Insert in a node with two data elements whose parent also contains two data elements.
                  </div>
               </div>
               <div class="art txt" title="Algorithm">
                  <div class="longt">
                     <h2 class="hlongt">Algorithm</h2>
                  </div>
                  <div class="art-body">
                     <ul>
                        <li>If the tree is empty, create a new node and insert the data item. <b>Done.</b></li>
                        <li>If the tree has only one node with one data element, insert the new element in this node. <b>Done.</b></li>
                        <li>Otherwise, search for the correct position of the new element.<br>
                        </li>
                        <li>If the new element is to be inserted in a node with only one data element. Perform insert and we're <b>done.</b>
                        </li>
                        <li>If the new element is to be inserted in a node with two data elements and whose parent contains only one data element.<br>
                           <ul>
                              <li>
                                 Insert the node in its correct position; this creates a <b>temporary node</b> with three data items.
                              </li>
                              <li>
                                 Split the temporary node, by moving the medium element to the root. This results in creation of a 3-Node and we're <b>done.</b>
                              </li>
                           </ul>
                        </li>
                        <li>If the new element is to be inserted in a node with two data elements and whose parent also contains two data elements.
                           <ul>
                              <li>
                                 Insert the node in its correct position, this creates a <b>temporary node</b> with three data items.
                              </li>
                              <li>
                                 Move the median element to the parent node and split the current node into two nodes. Now, the <b>parent becomes a temporary node with three elements.</b>
                              </li>
                              <li>
                                 Split the parent node by moving the median element one level up, this creates a new root of the current subtree and we're <b>done.</b>
                              </li>
                           </ul>
                        </li>
                     </ul>
                  </div>
               </div>
            </div>
            <div class="task" title="Deletion">
               <div class="longt">
                  <h2 class="hlongt">Deletion</h2>
               </div>
               <div class="art req" title="2-3 Deletion Video">
                  <div class="longt">
                     <h2 class="hlongt">2-3 Deletion Video</h2>
                  </div>
                  <div class="description">
                     <p>2-3 Deletion Video
                        should be displayed here!
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Intuition">
                  <div class="longt">
                     <h2 class="hlongt">Intuition</h2>
                  </div>
                  <div class="art-body">
                     <p>
                     	<ul>
                     		<li>
	                        Deletion in a 2-3 is again different from that of a Binary Search tree. Recall that, in a 2-3 tree there are two types of nodes viz., 2-Node and 3-Node. When we delete a data element from the node of a 2-3 tree, it might lead to the property of the tree being violated.</li>
	                        <li>
	                        In order to maintain the property of a 2-3 tree even after deletion of a data element, we perform various operations such as <b>merge</b>, <b>split</b> and <b>redistribution</b> of elements in the tree. </li>
                    	</ul>
                     </p>
                  </div>
               </div>
               <div class="art req" title="Delete Example 1">
                  <div class="longt">
                     <h2 class="hlongt">Delete a data element from an internal node.</h2>
                  </div>
                  <div class="description">
                     Delete a data element from an internal node.
                  </div>
               </div>
               <div class="art req" title="Delete Example 2">
                  <div class="longt">
                     <h2 class="hlongt">Delete a data element from leaf node.</h2>
                  </div>
                  <div class="description">
                     Delete a data element from leaf node.
                  </div>
               </div>
               <div class="art txt" title="Algorithm">
                  <div class="longt">
                     <h2 class="hlongt">Algorithm</h2>
                  </div>
                  <div class="art-body">
                     <ul>
                        <li>
                           If the data element to be deleted in the only element in the tree. Delete the node and we're done.
                        </li>
                        <li>
                           If the data element to be deleted is a present in the leaf. Then, delete the data element. However, this deletion will result in violation of the 2-3 tree property. To correct this, we perform redistribution and merging of elements in the node such that the property is preserved.
                        </li>
                        <li>
                           If the data element to be deleted is present in an internal node. Then, replace this data element with the inorder successor of the element. Now, delete the element according to step 2.
                        </li>
                     </ul>
                  </div>
               </div>
            </div>
            <div class="task" title="2-3 tree Demo">
               <div class="longt">
                  <h2 class="hlongt">Demo for operations on 2-3 tree</h2>
               </div>
               <div class="art req" title="2-3 tree Demo">
                  <div class="longt">
                     <h2 class="hlongt">Demo for operations on 2-3 tree</h2>
                  </div>
                  <div class="description">
                  </div>
               </div>
            </div>
            <div class="task" title="2-3 tree Practice">
               <div class="longt">
                  <h2 class="hlongt">Practice for operations on 2-3 tree</h2>
               </div>
               <div class="art req" title="2-3 tree Practice">
                  <div class="longt">
                     <h2 class="hlongt">Practice for operations on 2-3 tree</h2>
                  </div>
                  <div class="description">
                  </div>
               </div>
            </div>
            <div class="task" title="2-3 tree Exercise">
               <div class="longt">
                  <h2 class="hlongt">Exercise for operations on 2-3 tree</h2>
               </div>
               <div class="art req" title="2-3 tree Exercise">
                  <div class="longt">
                     <h2 class="hlongt">Exercise for operations on 2-3 tree</h2>
                  </div>
                  <div class="description">
                  </div>
               </div>
            </div>
         </div>

         <div class="lu" title="Post-Test">
            <div class="longt">
               <h1 class="hlongt">Post-Test Quiz</h1>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>10 minutes</p>
                  </div>
               </div>
               <div class="art txt" title="Instructions">
                  <div class="longt">
                     <h2 class="hlongt">Instructions for Post-Test</h2>
                  </div>
                  <div class="art-body">
                     <p>Post-test includes questions on
                     <ul>
                        <li>Insertion in 2-3 tree</li>
                        <li>Deletion in 2-3 tree</li>
                        <li>Search in a 2-3 tree</li>
                     </ul>
                     Read the questions below and select
                     the correct options from the ones given.
                     Some questions may have multiple correct
                     answers.
                     </p>
                  </div>
               </div>
            </div>

            <div class="quiz" title="Post-Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>
                    
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Which of the following statements are correct about a 2-3 tree?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) A 2-3 tree has either 2 keys or 3 keys in every node</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) A 2-3 has two types of nodes, namely 2-node and 3-node</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) A node in a 2-3 tree can have only only one child</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) A node in a 2-3 tree can have more than one root
</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>By definition, a 2-3 tree can have 2-node and 3-node.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. Key values in the nodes of a 2-3 tree always appear sorted from top to bottom and left to right in the tree. </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) True</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) False</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>
                                       Keys in a 2-3 tree are always sorted.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>
                                       Q3. Keys in a 2-3 tree are always sorted when __________.
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) All leaves in a 2-3 tree are at the same level</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Atleast one leaf node in a 2-3 tree has two chidren</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Leaf nodes in a 2-3 tree are allowed to have more than two children</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Leaf nodes in a 2-3 tree may or may not have child nodes</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>
                                       Leaf nodes in a 2-3 tree are at the same level
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. Which of the following is correct about a 2-node?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) A two node has only one child</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) A two node has one data element and two children </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) A two node has one data element and two children </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>
                                       A two node has one data element and two children.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                     <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q5. What is the time complexity of search in a 2-3 tree?  </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(log N)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(N)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(1)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(D) None of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>
                                       A 2-3 is a balanced tree so the time complexity of search is O(log N).
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
            <div class="lu" title="Further Readings/References">
            <div class="longt">
                <h2 class="hlongt">Further Readings and References of the Experiment</h2>
            </div>

            <div class="preamble">
                <div class="art txt" title="Explore">
                    <div class="longt">
                        <h2 class="hlongt">Explore 2-3 Tree</h2>
                    </div>
                    <div class="art-body">
                        <p>You can explore more about tree traversal through following resources:</p>
                        <p>
                            <h4>Theory</h4>
                            <ul>
                                <li><a href="https://en.wikipedia.org/wiki/2%E2%80%933_tree">Concept</a></li>
                                <li><a href="https://www.geeksforgeeks.org/2-3-trees-search-and-insert/">Search and Insert</a></li>
                            </ul>
                        </p>
                        <p>
                            <h4>Practice</h4>
                            <ul>
                                <li><a href="https://www.sanfoundry.com/2-3-tree-multiple-choice-questions-answers-mcqs/">OpenDSA</a></li>
                            </ul>
                        </p>
                        <p>
                            <h4>Quizzes</h4>
                            <ul>
                                <li><a href="https://www.goconqr.com/quiz/7128225/3-2-3-tree/">Questions and Answers</a></li>
        
                            </ul>
                        </p>
                    </div>
                </div>
            </div>
        </div>
         </div>
      </div>
      <script type="text/javascript" src="./js/loader.js"></script>
   </body>
</html>
